--AH:ScriptId=3734a8e3-968b-4d65-a3a6-760e22185536;273
CREATE TABLE [ChangeControls]
(
  [ChangeControl_Id] INT IDENTITY(1,1) NOT NULL,
  CONSTRAINT [PK_ChangeControls]
    PRIMARY KEY ([ChangeControl_Id]),
  
  [Application_Id] INT NOT NULL,
  [Release_Number] RELEASENUMBER NOT NULL,
  CONSTRAINT [FK__ChangeControl__Releases]
    FOREIGN KEY ([Application_Id], [Release_Number])
    REFERENCES [Releases]([Application_Id], [Release_Number]),
  
  [Group_Name] VARCHAR(100) NOT NULL,
  [Description_Text] VARCHAR(MAX) NOT NULL,
  
  -- U - The principal is a User; G - The principal is a Group
  [Principal_Name] USERNAME NOT NULL,
  [PrincipalType_Code] CHAR(1) NOT NULL,
  CONSTRAINT [CK__ChangeControls__PrincipalType_Code__Domain]
    CHECK ([PrincipalType_Code] IN ('U', 'G')),
    
  -- E - Once per execution; P - Once per promotion; M - Manual
  [PerformanceType_Code] CHAR(1) NOT NULL,
  CONSTRAINT [CK__ChangeControls__PerformanceType_Code__Domain]
    CHECK ([PerformanceType_Code] IN ('E', 'P', 'M')),
    
  [CreatedBy_User_Name] USERNAME NOT NULL,
  [CreatedOn_Date] DATETIME NOT NULL,
  [ModifiedBy_User_Name] USERNAME NOT NULL,
  [ModifiedOn_Date] DATETIME NOT NULL,
    
  [Active_Indicator] YNINDICATOR NOT NULL
)

CREATE TABLE [ChangeControlEnvironments]
(
  [ChangeControl_Id] INT NOT NULL,
  CONSTRAINT [FK__ChangeControlEnvironments__ChangeControls]
    FOREIGN KEY ([ChangeControl_Id])
    REFERENCES [ChangeControls]([ChangeControl_Id]),
    
  [Environment_Id] INT NOT NULL,
  CONSTRAINT [FK__ChangeControlEnvironments__Environments]
    FOREIGN KEY ([Environment_Id])
    REFERENCES [Environments]([Environment_Id]),
  
  CONSTRAINT [PK__ChangeControlEnvironments]
  PRIMARY KEY ([ChangeControl_Id], [Environment_Id])
)

CREATE TABLE [ChangeControlPerformances]
(
  [ChangeControlPerformance_Id]  INT IDENTITY(1,1) NOT NULL,
  CONSTRAINT [PK_ChangeControlPerformances]
    PRIMARY KEY ([ChangeControlPerformance_Id]),
      
  [ChangeControl_Id] INT NOT NULL,
  CONSTRAINT [FK__ChangeControlPerformances__ChangeControls]
    FOREIGN KEY ([ChangeControl_Id])
    REFERENCES [ChangeControls]([ChangeControl_Id]),
    
  [Environment_Id] INT NOT NULL,
  CONSTRAINT [FK__ChangeControlPerformances__Environments]
    FOREIGN KEY ([Environment_Id])
    REFERENCES [Environments]([Environment_Id]),
    
  [PerformedBy_User_Name] USERNAME NOT NULL,
  
  [Performed_Date] DATETIME NOT NULL,
  
  [Notes_Text] VARCHAR(MAX) NULL,
  
  [Execution_Id] INT NULL,
  CONSTRAINT [FK__ChangeControlPerformances__BuildExecutions]
    FOREIGN KEY ([Execution_Id])
    REFERENCES [BuildExecutions]([Execution_Id])
)
