--AH:ScriptId=bb01fff7-355b-4768-9387-163fc608b277;327
ALTER TABLE [Environments]
  ADD [Display_Sequence] INT
GO
  
DECLARE @TB TABLE ( [Display_Sequence] INT IDENTITY(1,1), [Environment_Id] INT)
INSERT INTO @TB([Environment_Id])
SELECT E.[Environment_Id]
  FROM [Environments] E
	   LEFT JOIN 
	   (
	      SELECT [Environment_Id], MAX([Workflow_Step_Sequence]) [Workflow_Step_Sequence]
             FROM (
					SELECT A.[Application_Id]
						  ,E.[Environment_Id]
						  ,[Workflow_Step_Sequence] = dWS.[Step_Sequence]
					  FROM [Applications] A
						   JOIN (SELECT _W.[Application_Id], _WS.[Environment_Id], MAX(_WS.[Step_Sequence]) [Step_Sequence]
								   FROM [WorkflowSteps] _WS
										JOIN [Workflows] _W
										  ON _W.[Workflow_Id] = _WS.[Workflow_Id]
										 AND _W.[Active_Indicator] = 'Y'
								  GROUP BY _W.[Application_Id], _WS.[Environment_Id]) dWS
							 ON A.[Application_Id] = dWS.[Application_Id]
						   JOIN [Environments] E
							 ON dWS.[Environment_Id] = E.[Environment_Id]
                  ) X
            GROUP BY [Environment_Id]
	   ) AEM ON E.[Environment_Id] = AEM.[Environment_Id]
ORDER BY CASE WHEN AEM.[Workflow_Step_Sequence] IS NULL THEN 2 ELSE 1 END
		,AEM.[Workflow_Step_Sequence]
		,CASE WHEN E.[Environment_Name] LIKE 'Dev%' THEN 1
              WHEN E.[Environment_Name] LIKE 'Int%' THEN 2
              WHEN E.[Environment_Name] LIKE 'Test%' THEN 3
              WHEN E.[Environment_Name] LIKE 'Beta%' THEN 4
              WHEN E.[Environment_Name] LIKE 'Q%' THEN 4
              WHEN E.[Environment_Name] LIKE 'Sta%' THEN 5
              WHEN E.[Environment_Name] LIKE 'Prod%' THEN 6
              WHEN E.[Environment_Name] LIKE 'Live%' THEN 6 ELSE 99 END   
  
UPDATE [Environments]
   SET [Display_Sequence] = T.[Display_Sequence]
  FROM [Environments] E INNER JOIN @TB T ON E.[Environment_Id] = T.[Environment_Id]
GO

ALTER TABLE [Environments]
ALTER COLUMN [Display_Sequence] INT NOT NULL

ALTER TABLE [Environments]
 ADD CONSTRAINT [UQ__Environments__Display_Sequence] UNIQUE ([Display_Sequence])

ALTER TABLE [Environments]
 ADD CONSTRAINT [CK__Environments__Display_Sequence_Domain] 
     CHECK ([Display_Sequence]>0)

-- ALTER TABLE [Environments] DROP CONSTRAINT [CK__Environments__Display_Sequence_Domain] 
-- ALTER TABLE [Environments] DROP CONSTRAINT [UQ__Environments__Display_Sequence]
-- ALTER TABLE [Environments]   DROP COLUMN [Display_Sequence]