IF OBJECT_ID('Environments_GetAncestorEnvironments') IS NOT NULL DROP FUNCTION Environments_GetAncestorEnvironments
GO

CREATE FUNCTION [Environments_GetAncestorEnvironments]
(
	@Environment_Id INT
) RETURNS @environments TABLE ([Level] INT NOT NULL, [Environment_Id] INT NOT NULL)
BEGIN

    DECLARE @Depth INT
    SET @Depth = 0

    DECLARE @ParentId INT
    DECLARE @TmpParentId INT
	DECLARE @TmpEnvId INT

    SELECT @TmpEnvId = [Environment_Id], 
		   @ParentId = [Parent_Environment_Id] 
      FROM [Environments] 
     WHERE [Environment_Id] = @Environment_Id

	 -- no environment with specified ID
	 IF @TmpEnvId IS NULL
        RETURN

    -- add specified environment at depth 0
    INSERT INTO @environments ([Level], [Environment_Id])
        VALUES (0, @Environment_Id)

    WHILE (@ParentId IS NOT NULL) 
    BEGIN
        SET @Depth = @Depth + 1

        INSERT INTO @environments ([Level], [Environment_Id])
        VALUES (@Depth, @ParentId)
        
        SELECT @TmpParentId = [Parent_Environment_Id] FROM [Environments] WHERE [Environment_Id] = @ParentId
        SET @ParentId = @TmpParentId

        -- sanity check
        IF @Depth > 1000
            BREAK

    END
  
  RETURN
END
GO