IF OBJECT_ID('[BuildArtifacts_Slim]') IS NOT NULL DROP VIEW [BuildArtifacts_Slim]
GO

CREATE VIEW [BuildArtifacts_Slim] AS

	SELECT A.[Application_Id]
	      ,R.[Release_Id]
		  ,R.[Release_Number]
		  ,B.[Build_Id]
		  ,B.[Build_Number]
		  ,BA.[Deployable_Id]
		  ,BA.[Artifact_Name]
		  ,BA.[Execution_Id]
		  ,BA.[Created_Date]
		  ,B.[BuildStatus_Name]
		  ,BA.[Artifact_Path]

	  FROM [BuildArtifacts] BA
		   INNER JOIN [Builds] B
				   ON BA.[Build_Id] = B.[Build_Id]
		   INNER JOIN [Releases] R
		           ON R.[Release_Id] = B.[Release_Id]
		   INNER JOIN [Applications] A
		           ON A.[Application_Id] = R.[Application_Id]

GO
