IF OBJECT_ID('[Builds_Slim]') IS NOT NULL DROP VIEW [Builds_Slim]
GO

CREATE VIEW [Builds_Slim] AS

SELECT R.[Release_Id]
	  ,R.[Release_Number]
      ,R.[Release_Sequence]
	  ,B.[Build_Id]
      ,B.[Build_Number]
      ,B.[BuildStatus_Name]
	  ,R.[Pipeline_Id]
      ,B.[Furthest_PipelineStage_Name]
      ,B.[CreatedOn_Date]
      ,[Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number])
      ,R.[ReleaseStatus_Name]
	  ,B.[Build_Sequence]
	  ,A.[Application_Id]
	  ,A.[Application_Name]

  FROM [Builds] B
       INNER JOIN [Releases] R
               ON B.[Release_Id] = R.[Release_Id]
       INNER JOIN [Applications] A
               ON R.[Application_Id] = A.[Application_Id]
GO
