IF OBJECT_ID('[DeploymentPlans_ActionUsage]') IS NOT NULL DROP VIEW [DeploymentPlans_ActionUsage]
GO

CREATE VIEW [DeploymentPlans_ActionUsage] AS

SELECT DPAG.[DeploymentPlanActionGroup_Id],
       [ActionGroup_Name] = COALESCE(DPAG.[ActionGroup_Name], AG.[ActionGroup_Name]),
       DPAG.[DeploymentPlanActionGroup_Sequence],
       DPAG.[ActionGroup_Id],
       DP.[DeploymentPlan_Id],
       DP.[DeploymentPlan_Name],
       AGA.[Action_Sequence],
       [Uses_DeploymentPlan_Id] = DP_Uses.[DeploymentPlan_Id],
       [Uses_DeploymentPlan_Name] = DP_Uses.[DeploymentPlan_Name]
  FROM [DeploymentPlanActionGroups] DPAG
       INNER JOIN [DeploymentPlans] DP
               ON DP.[DeploymentPlan_Id] = DPAG.[DeploymentPlan_Id]
       INNER JOIN [ActionGroups] AG
               ON AG.[ActionGroup_Id] = DPAG.[ActionGroup_Id]
       INNER JOIN [ActionGroupActions] AGA
               ON DPAG.[ActionGroup_Id] = AGA.[ActionGroup_Id]
       INNER JOIN [DeploymentPlans] DP_Uses
               ON DP_Uses.[DeploymentPlan_Id] = AGA.[Action_Configuration].value('/*[1]/Properties[1]/@DeploymentPlanId', 'INT')
 WHERE CAST(AGA.[Action_Configuration].query('local-name(/*[1])') AS VARCHAR(200)) = 'Inedo.BuildMaster.Extensibility.Actions.BuildMaster.ExecuteDeploymentPlanAction'
   AND AGA.[Action_Configuration].value('/*[1]/@Assembly', 'VARCHAR(200)') = 'BuildMasterExtensions'

GO
