IF OBJECT_ID('[Issues_Extended]') IS NOT NULL DROP VIEW [Issues_Extended]
GO

CREATE VIEW [Issues_Extended] AS
	SELECT I.[Application_Id],
	       A.[Application_Name],
		   A.[ApplicationGroup_Id],
		   AG.[ApplicationGroup_Name],
		   R.[Release_Id],
		   R.[Release_Number],
		   [Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number]),
           R.[Release_Sequence],
		   I.[Issue_Id],
           I.[Type_Text],
		   I.[Title_Text],
		   I.[Description_Text],
		   I.[Closed_Indicator],
		   I.[ClosedOn_Date],
           I.[OpenedOn_Original_Build_Number],
           [OpenedOn_Original_Build_Sequence] = B_OPENED.[Build_Sequence],
           I.[ClosedOn_Original_Build_Number],
           [ClosedOn_Original_Build_Sequence]= B_CLOSED.[Build_Sequence],
		   I.[CreatedBy_User_Name],
		   I.[CreatedOn_Date],
		   I.[IssueTracker_IssueId_Text],
		   I.[IssueTracker_IssueStatus_Text],
		   I.[IssueTracker_LastSync_Date],
           I.[IssueTracker_IssueUrl_Text],
           [BuildMasterIssue_Indicator] = CASE WHEN I.[IssueTracker_IssueId_Text] IS NULL THEN 'Y' ELSE 'N' END
                                          
	  FROM [Issues] I
	       INNER JOIN [Applications] A
		           ON A.[Application_Id] = I.[Application_Id]
		    LEFT JOIN [ApplicationGroups] AG
			       ON AG.[ApplicationGroup_Id] = A.[ApplicationGroup_Id]
		    LEFT JOIN [Releases] R
		           ON R.[Release_Id] = I.[Release_Id]
            LEFT JOIN [Builds] B_OPENED
                   ON B_OPENED.[Release_Id] = I.[Release_Id]
                  AND B_OPENED.[Build_Number] = I.[OpenedOn_Original_Build_Number]
            LEFT JOIN [Builds] B_CLOSED
                   ON B_CLOSED.[Release_Id] = I.[Release_Id]
                  AND B_CLOSED.[Build_Number] = I.[ClosedOn_Original_Build_Number]
GO