IF OBJECT_ID('[VariableDefinitions_System]') IS NOT NULL DROP VIEW [VariableDefinitions_System]
GO

CREATE VIEW [VariableDefinitions_System] AS

SELECT VDEF.*
      ,E.[Environment_Name]
      ,S.[Server_Name]
      ,AG.[ApplicationGroup_Name]
      ,[Application_Name] = COALESCE(A.[Application_Name],AD.[Application_Name])
      ,D.[Deployable_Name]
  FROM [VariableDefinitions] VDEF
       LEFT JOIN [Applications] A
              ON VDEF.[Application_Id] = A.[Application_Id]
       LEFT JOIN [ApplicationGroups] AG
              ON VDEF.[ApplicationGroup_Id] = AG.[ApplicationGroup_Id]
       LEFT JOIN [Environments] E
              ON VDEF.[Environment_Id] = E.[Environment_Id]
       LEFT JOIN [Deployables] D
              ON VDEF.[Deployable_Id] = D.[Deployable_Id]
       LEFT JOIN [Applications] AD
              ON D.[Application_Id] = AD.[Application_Id]
       LEFT JOIN [Servers] S
              ON VDEF.[Server_Id] = S.[Server_Id]
  
  WHERE [Scope_Code] IN ('S','E','V','G','A','D')

GO