EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Builds_GetExecutionExtended',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'BuildExecutions_Extended,BuildExecution_DeploymentPlans,BuildExecution_DeploymentPlanActionGroups,BuildExecution_ActionGroupActions,BuildExecution_ActionGroupActionLogEntries',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all details regarding a specific build execution.'
GO

IF OBJECT_ID('[Builds_GetExecutionExtended]') IS NOT NULL DROP PROCEDURE [Builds_GetExecutionExtended]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Builds_GetExecutionExtended]
(
	@Execution_Id INT
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [BuildExecutions_Extended]
	 WHERE [Execution_Id] = @Execution_Id

	SELECT *
	  FROM [BuildExecution_DeploymentPlans]
	 WHERE [Execution_Id] = @Execution_Id

	SELECT BEDPAG.*
	  FROM [BuildExecution_DeploymentPlanActionGroups] BEDPAG
	       INNER JOIN [BuildExecution_DeploymentPlans] BEDP
	               ON BEDP.[BuildExecution_DeploymentPlan_Id] = BEDPAG.[BuildExecution_DeploymentPlan_Id]
	 WHERE BEDP.[Execution_Id] = @Execution_Id
	 
	SELECT BEAGA.*
	  FROM [BuildExecution_ActionGroupActions] BEAGA
	       INNER JOIN [BuildExecution_DeploymentPlans] BEDP
	               ON BEDP.[BuildExecution_DeploymentPlan_Id] = BEAGA.[BuildExecution_DeploymentPlan_Id]
	 WHERE BEDP.[Execution_Id] = @Execution_Id

	SELECT BEAGALE.*
	  FROM [BuildExecution_ActionGroupActionLogEntries] BEAGALE
	       INNER JOIN [BuildExecution_ActionGroupActions] BEAGA
		           ON BEAGA.[BuildExecution_ActionGroupAction_Id] = BEAGALE.[BuildExecution_ActionGroupAction_Id]
		   INNER JOIN [BuildExecution_DeploymentPlans] BEDP
		           ON BEDP.[BuildExecution_DeploymentPlan_Id] = BEAGA.[BuildExecution_DeploymentPlan_Id]
	 WHERE BEDP.[Execution_Id] = @Execution_Id
	   AND BEAGA.[Original_Action_Sequence] = 0
	   AND BEAGA.[Original_DeploymentPlanActionGroup_Sequence] = 0
	   AND BEDP.[Original_DeploymentPlan_Id] = 0
	 ORDER BY BEAGALE.[LogEntry_Sequence]

END
GO

GRANT EXECUTE ON [Builds_GetExecutionExtended] TO [BuildMasterUser_Role]
