EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Credentials_GetCredentialByName',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'Credentials_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the specified credential by its qualified name.'
GO


IF OBJECT_ID('[Credentials_GetCredentialByName]') IS NOT NULL DROP PROCEDURE [Credentials_GetCredentialByName]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Credentials_GetCredentialByName]
(
    @CredentialType_Name NVARCHAR(50),
    @Credential_Name NVARCHAR(50)
)
AS
BEGIN

	SET NOCOUNT ON

	IF @CredentialType_Name IS NOT NULL
    BEGIN

        SELECT * FROM [Credentials_Extended]
         WHERE [CredentialType_Name] = @CredentialType_Name
           AND [Credential_Name] = @Credential_Name

    END
    ELSE
    BEGIN
        IF (SELECT COUNT([Credential_Id])
                   FROM [Credentials]
                  WHERE [Credential_Name] = @Credential_Name) > 1
        BEGIN
            RAISERROR('The specified credential is not unique solely by its name, please specify a type name in addition to the credential name.', 16, 1)
        END
        ELSE
        BEGIN

            SELECT * 
              FROM [Credentials_Extended]
             WHERE [Credential_Name] = @Credential_Name
            
        END
    END
END
GO

GRANT EXECUTE ON [Credentials_GetCredentialByName] TO [BuildMasterUser_Role]