EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Executions_GetEstimatedDuration',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'DeploymentPlanRuns',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the estimated length of time for an execution based on its run context hash.'
GO

IF OBJECT_ID('[Executions_GetEstimatedDuration]') IS NOT NULL DROP PROCEDURE [Executions_GetEstimatedDuration]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Executions_GetEstimatedDuration]
(
	@DeploymentPlan_Id INT,
    @RunContextHash_Bytes BINARY(16)
)
AS
BEGIN

SET NOCOUNT ON

        SELECT TOP 1 * 
          FROM [DeploymentPlanRuns]
         WHERE [DeploymentPlan_Id] = @DeploymentPlan_Id
         ORDER BY 
                CASE WHEN [RunContextHash_Bytes] = @RunContextHash_Bytes THEN 0 ELSE 1 END,
                [LastRun_Date] DESC

END
GO

GRANT EXECUTE ON [Executions_GetEstimatedDuration] TO [BuildMasterUser_Role]
