EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'IssueSources_CreateOrUpdateIssueSource',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ NULL,
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'IssueSource_Id',
    /* Description_Text        */ 'Creates or updates the specified issue source.'
GO

IF OBJECT_ID('[IssueSources_CreateOrUpdateIssueSource]') IS NOT NULL DROP PROCEDURE [IssueSources_CreateOrUpdateIssueSource]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [IssueSources_CreateOrUpdateIssueSource]
(
    @IssueSource_Name VARCHAR(255),
    @Application_Id INT,
    @ApplicationGroup_Id INT,
    @IssueSource_Configuration XML,
    @IssueSource_Id INT = NULL OUT
)
AS
BEGIN

	SET NOCOUNT ON

    IF NOT EXISTS(SELECT * FROM [IssueSources] WHERE [IssueSource_Id] = @IssueSource_Id)
    BEGIN
        
        INSERT INTO [IssueSources] 
        (
            [IssueSource_Name]
           ,[Application_Id]
           ,[ApplicationGroup_Id]
           ,[IssueSource_Configuration]
        )
        VALUES 
        (
            @IssueSource_Name
           ,@Application_Id
           ,@ApplicationGroup_Id 
           ,@IssueSource_Configuration
        )

        SET @IssueSource_Id = SCOPE_IDENTITY()

    END
    ELSE
    BEGIN

	    UPDATE [IssueSources]
           SET [IssueSource_Name] = @IssueSource_Name
              ,[Application_Id] = @Application_Id
              ,[ApplicationGroup_Id] = @ApplicationGroup_Id
              ,[IssueSource_Configuration] = @IssueSource_Configuration
         WHERE [IssueSource_Id] = @IssueSource_Id

     END

END
GO

GRANT EXECUTE ON [IssueSources_CreateOrUpdateIssueSource] TO [BuildMasterUser_Role]