EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'IssueSources_UpdateLastPull',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ NULL,
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'IssueSource_Id',
    /* Description_Text        */ 'Updates the last pull and execution for the specified issue source.'
GO

IF OBJECT_ID('[IssueSources_UpdateLastPull]') IS NOT NULL DROP PROCEDURE [IssueSources_UpdateLastPull]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [IssueSources_UpdateLastPull]
(
    @IssueSource_Id INT,
    @Last_Pull_Date DATETIME,
    @Last_Execution_Id INT
)
AS
BEGIN

        UPDATE [IssueSources]
           SET [Last_Pull_Date] = COALESCE(@Last_Pull_Date,[Last_Pull_Date])
              ,[Last_Execution_Id] = COALESCE(@Last_Execution_Id,[Last_Execution_Id])
         WHERE [IssueSource_Id] = @IssueSource_Id

END
GO

GRANT EXECUTE ON [IssueSources_UpdateLastPull] TO [BuildMasterUser_Role]