EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Plans_ImportPlanVersion',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Imports an OtterScript deployment plan version.'
GO

IF OBJECT_ID('[Plans_ImportPlanVersion]') IS NOT NULL DROP PROCEDURE [Plans_ImportPlanVersion]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Plans_ImportPlanVersion]
(
	@Plan_Id INT,
	@PlanVersion_Id INT,
	@ModifiedOn_Date DATETIME,
	@ModifiedBy_User_Name USERNAME,
    @Plan_Bytes VARBINARY(MAX)
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [PlanVersions]
	(
		[PlanVersion_Id],
		[Plan_Id],
		[ModifiedOn_Date],
		[ModifiedBy_User_Name],
		[Plan_Bytes]
	)
	VALUES
	(
		@PlanVersion_Id,
		@Plan_Id,
		@ModifiedOn_Date,
		@ModifiedBy_User_Name,
		@Plan_Bytes
	)

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Plans_ImportPlanVersion] TO [BuildMasterUser_Role]
