EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'RetentionPolicies_PurgeNow',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Marks a retention policy as ready to run immediately.'
GO


IF OBJECT_ID('[RetentionPolicies_PurgeNow]') IS NOT NULL DROP PROCEDURE [RetentionPolicies_PurgeNow]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [RetentionPolicies_PurgeNow]
(
	@RetentionPolicy_Id INT
)
AS
BEGIN

	SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	UPDATE [RetentionPolicies]
	   SET [PurgeNow_Indicator] = 'Y'
	 WHERE [RetentionPolicy_Id] = @RetentionPolicy_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [RetentionPolicies_PurgeNow] TO [BuildMasterUser_Role]