EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Scripts_GetScripts',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Scripts_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all of the scripts in the system, optionally filtered by type code.'
GO


IF OBJECT_ID('[Scripts_GetScripts]') IS NOT NULL DROP PROCEDURE [Scripts_GetScripts]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Scripts_GetScripts]
(
	@ScriptType_Code VARCHAR(20),
	@IncludeInactive_Indicator YNINDICATOR
)
AS
BEGIN

SET NOCOUNT ON

	SELECT *
	  FROM [Scripts_Extended]
	 WHERE (@IncludeInactive_Indicator = 'Y' OR [Active_Indicator] = 'Y')
	   AND (@ScriptType_Code IS NULL OR [ScriptType_Code] = @ScriptType_Code)
	 ORDER BY [Script_Name]

END
GO

GRANT EXECUTE ON [Scripts_GetScripts] TO [BuildMasterUser_Role]
