EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Variables_GetVariableDefinitions',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'VariableDefinitions_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the variable definitions in the system that are defined in the specified scope'
GO


IF OBJECT_ID('[Variables_GetVariableDefinitions]') IS NOT NULL DROP PROCEDURE [Variables_GetVariableDefinitions]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Variables_GetVariableDefinitions]
(
    @Environment_Id INT,
    @ServerRole_Id INT,
    @Server_Id INT,
    @ApplicationGroup_Id INT,
    @Application_Id INT,
    @Deployable_Id INT,
    @Release_Id INT,
    @Build_Id INT,
    @Execution_Id INT
)
AS
BEGIN

    SET NOCOUNT ON

    SELECT *
      FROM [VariableDefinitions_Extended]
     WHERE ([Environment_Id] = @Environment_Id OR ([Environment_Id] IS NULL AND @Environment_Id IS NULL))
       AND ([Server_Id] = @Server_Id OR ([Server_Id] IS NULL AND @Server_Id IS NULL))
       AND ([ServerRole_Id] = @ServerRole_Id OR ([ServerRole_Id] IS NULL AND @ServerRole_Id IS NULL))
       AND ([ApplicationGroup_Id] = @ApplicationGroup_Id OR ([ApplicationGroup_Id] IS NULL AND @ApplicationGroup_Id IS NULL))
       AND ([Deployable_Id] = @Deployable_Id OR ([Deployable_Id] IS NULL AND @Deployable_Id IS NULL))
       
       AND ([Application_Id] = @Application_Id OR ([Application_Id] IS NULL AND @Application_Id IS NULL))
       AND ([Release_Id] = @Release_Id OR ([Release_Id] IS NULL AND @Release_Id IS NULL))
       AND ([Build_Id] = @Build_Id OR ([Build_Id] IS NULL AND @Build_Id IS NULL))
       
       AND ([Execution_Id] = @Execution_Id OR ([Execution_Id] IS NULL AND @Execution_Id IS NULL))


END
GO

GRANT EXECUTE ON [Variables_GetVariableDefinitions] TO [BuildMasterUser_Role]